Subject: Re: [PATCH 0/3] commit-graph: fix corruption during generation v2 upgrade

From: Junio C Hamano <[email-masked]>
Date: Wed, 13 Jul 2022 10:41:45 -0700

Taylor Blau <[email-masked]> writes:

> This brief series resolves a bug where a commit-graph would become
> corrupt when upgrading from generation number v1 to v2, as originally
> reported in [1].
>
> Some speculation occurred as to what might be causing that bug in the
> thread beginning at [1], until the problem was explained in more detail
> by Will Chandler in [2].
>
> The crux of the issue, as is described in [2] and [3], is that the
> commit_graph_data slab is reused for read and write operations involving
> the commit-graph, leading to situations where data computed in
> preparation of a write is clobbered by a read of existing data.
>
> The first patch demonstrates the issue, and the second patch prepares to
> fix it by introducing a helper function. The crux of the issue is
> described and fixed in the third patch.
>
> [1]: https://lore.kernel.org/git/[email-masked]/
> [2]: https://lore.kernel.org/git/[email-masked]/
> [3]: https://lore.kernel.org/git/[email-masked]/

Thanks.  Do we know where this breaks?  Applying [1/3] on Git 2.32,
2.34, and 2.35 seems to claim that "known breakage vanished".